# kylin-kmre
## Overview
kylin-kmre is a system environment compatible with Android APP designed by Kylin team for "KYLIN Operating system", which is used to meet the diverse needs of users for application software.Users can install and run Android apps in KYLIN operating system by kylin-kmre, such as WeChat, qqlite, stocks, video apps etc.

### Technical Features
1）kylin-kmre is already compatible with a large number of Android apps and takes only a second to boot.

2）There is no performance,kylin-kmre uses graphics hardware.

3）App integration with Linux window display.

4）Support multi-program running.

5）Resolution dynamic adaptation,free rotation and UHD.

6）The input method is unified, the system input method can be used in the APP.

7）Same audio device, voice support.

8）Camera Support.

9）Document,clipping board, application management intercommunication.

10）Support WeChat, qqlite new message notification.

11）Support WeChat tablet mode login and mobile WeChat online at the same time.

12）System compatibility, security, stability greatly improved after upgrading to Android 11.

<br>

## Care Instruction
Due to the technical design of Android system and the sharing of hardware resources between kylin-kmre and Kylin operating system, in order to achieve a better use experience, users are advised to read the following notes and known issues carefully:

1）The performance of APP will be greatly improved when using SSD compared to using mechanical hard disk;

2）Do not run more than 4 apps at the same time(Android typically has only one active App running on the front end);

3）Recommended memory 8GB or more;

4）CPU support: FT-2000/4, Phytium D2000/8, FT1500A, Kirin990, Hygon, ZHAOXIN, Intel and AMD;

5）Graphics support：NVIDIA, AMD, INTEL, JJM and GP101. On JJM and GP101, the system performance is poor. Stags and flashbacks may occur, even some applications may work;

6）The voice and video calls were normal but the video was abnormal for qqlite;

7）You need to pause other audio/video playback when using Communication software. Otherwise, audio and video calling software may run into the problem of not hearing the other person's voice;

8）The camera should be connected before the kylin-kmre environment is started. If the camera is connected after the environment starts, the camera will not be used normally. The current version may have a green screen when using the camera on some machines;

9）The machine with a WiFi device, such as a laptop or a desktop computer with Wireless network card. Before starting kylin-kmre, you need to make sure that the WiFi switch is on. Otherwise, if you start kylin-kmre when WiFi is off, all the apps in kylin-kmre will not be connected to the Internet;

10）The screen brightness adjustment feature for video apps will not work;

11）The PIP is not supported;

12）Positioning and sensors are not supported;

13）DingTalk login, if you use the DingTalk to punch in or other functions, you need to log out the account in the kylin-kmre, otherwise there may be "virtual positioning software punch in";

14）Lanxin requires the phone to log out of the account before the voice call function can be used;

15）If the system installed Qianxin network terminal security management system, pay attention to the version number.8.0.5.1000, will cause Docker exception, which will make Android compatibility unusable, and the app store "phone" page can not refresh successfully;

16）Virtual machine is not supported.

<br>

## Application startup
### Start App from Kylin store
Click the UKUI Menu -> Kylin Software Store as Figure 1.When the Kylin Store opens, click the "Mobile Apps" button at the top of the window. If this is the first time you start the application, you need to initialize the kylin-kmre environment. During this process, a prompt box will pop up in the lower right corner of the desktop, as Figure 2. When the kylin-kmre environment is ready, the prompt box exit.The Kylin store "Mobile Apps" page will display a list of mobile apps and you can install them as Figure 3.

![Figure 1 Start Kylin store from UKUI menu-big](image/1.png)

![Figure 2 Initialize the kylin-kmre-big](image/2.png)

![Figure 3 A list of mobile apps that can be installed-big](image/3.png)

When the kylin-kmre is ready and the mobile application is installed. You can choose to open your mobile app through the Kylin Store. Hover the mouse over the installed app, as shown in Figure 4, and click the "Open" button to display the interface of the corresponding mobile app, as shown in Figure 5.

![Figure 4 Start mobile app-big](image/4.png)

![Figure 5 opening mobile app](image/5.png)

### Launch the mobile application from the UKUI Menu shortcut
Click the UKUI menu in the lower left corner of the desktop, and click the Android app icon to start the app.As shown in figure 6.

![Figure 6 Start the mobile application in Kylin Menu Normal mode-big](image/6.png)

<br>

## Close the kylin-kmre
### Close
Click the "About & Help" button in the middle of the toolbar at the bottom of the graphical window of Android apps, as shown in Figure 7 and Figure 8.Select "Close kylin-kmre" from the pop-up menu to close the kylin-kmre and close all Android app Windows.

![Figure 7 Click the mobile app icon in the penal](image/7png)

![Figure 8 Switch by Alt+Tab-big](image/8.png)

### Full-screen mobile app window
The window toolbar has five buttons, return, virtual key setting, about & help, resize, and full screen, as shown in Figure 9.Click the Fullscreen button and the app will appear in full screen.In full-screen mode, a black floating toolbar appears at the far right of the screen when the mouse is moved, as shown in Figure 10.Clicking the button on the floating toolbar displays a toolbar that includes Back, virtual key Settings, About & Help, resize, and full-screen buttons, as shown in Figure 11。You can switch between full screen and non-full screen by pressing "F11", and support "ESC" to exit full screen.

![Figure 9 Toolbar](image/9.png)

![Figure 10 Full screen right floating toolbar-big](image/10.png)

![Figure 11 Full screen right fixed taskbar-big](image/11.png)

<br>

## Install and uninstall mobile applications
- Install and update:After the store is opened, click the "Mobile Application" button at the top of the interface, and the list of mobile applications will appear in the window. Move the mouse over the application and click the "Download" button, as shown in Figure 12. After installation, the "Download" button will become the "Open" button.

![Figure 12 Install the application-big](image/12.png)

- Uninstall：Kylin store  ->my apps  ->uninstall,Select the software to be uninstalled and click the "Uninstall" button to begin uninstalling,as figure 13.

![Figure 13 Uninstall-big](image/13.png)

<br>

## Input
### Chinese input
kylin-kmre and Kirin share input methods. After switching the input method, you can directly input Chinese in the input box of the mobile application, as shown in Figure 14.

![Figure 14 Chinese input-big](image/14.png)

### Keyboard
kylin-kmre supports keyboard key input, including keypad and various key combinations, such as Ctrl+C, Ctrl+V, etc，as figure 15.

![Figure 15 keyboard-big](image/15.png)

<br>

## File sharing
In Kylin Linux V10, kylin-kmre provides Kylin and mobile application environment file interoperability. After kylin-kmre start, a shortcut called "Mobile Application Data" is created on the current user's desktop.You can access data inside the kylin-kmre by double-clicking the shortcut.kylin-kmre also offers a plug-in based on file manager Peony, which allows you to view and copy four types of Android files in the file manager: pictures, videos, audio and documents.Android applications can directly access the system's files, greatly facilitating file transfer and access.

* View and access files in Android through the "Mobile App Data" shortcut on the desktop, as shown in Figure 16.Take wechat as an example. Photos and videos saved via WeChat are stored in directory "Desktop"->"Mobile App Data"->"Pictures"->"WeiXin". The doc documents, PDF documents and compressed files saved through WeChat are in the directory "Desktop" -> "Mobile App Data" -> "Android" -> "data" -> "com.tencent.mm" -> "MicroMsg" -> "Download".

![Figure 16 Mobile app data folder-big](image/16.png)

* View and access the files in Android through the Android file classification display tool "mobile data file manager" in the menu bar, as shown in Figure 17, Figure 18, figure 19 and Figure 20. For example, pictures and documents saved through Android wechat can be viewed in this tool.

![Figure 17 Mobile data manager in menu bar](image/17.png)

![Figure 18 Main interface of mobile data manager-big](image/18.png)

![Figure 19 Mobile Data Manager-video-big](image/19.png)

![Figure 20 Mobile Data Manager-docment-big](image/20.png)

* Android apps access Kylin data directly(talk Wechat as example)

  - （a）Sends photos:As shown in Fig. 21, Fig. 22 and Fig. 23, click the "Album" button of WeChat and select to enter a folder on the pop-up interface to send the pictures in the folder to friends.

  ![Figure 21 Wechat Photo selection entry](image/21.png)

  ![Figure 22 WeChat Selectable all picture directories](image/22.png)

  ![Figure 23 Select the photo to send](image/23.png)

  - （b）Send the document:As shown in Fig. 24, Fig. 25, Fig. 26 and Fig. 27, first click the "File" button of WeChat, select "Mobile Storage" on the pop-up interface, and then select "0-Kylin File" to send the files of Kylin to friends.

  ![Figure 24 Select the entry of the document file](image/24.png)

  ![Figure 25 Select the list item for the file](image/25.png)

  ![Figure 26 Select a document file from the phone store](image/26.png)

  ![Figure 27 Select the document file to send](image/27.png)

<br>

## Configure the network
kylin-kmre runs in a Docker container. If the network configuration of Docker is the same as the network segment of the user's machine, such as the network segment beginning with 172, then there will be no network in the kylin-kmre in the container.

In this case, you can modify Docker's network configuration file /etc/docker/daemon.json, and then restart the kylin-kmre to solve the problem.If this file does not exist, you can create it yourself and add something as the following:

    {
      "bip": "128.128.0.1/16"
    }

<br>

## Game keyboard whitelist Settings
kylin-kmre can set up buttons for game operations. The list of games where button operations can be set is in /usr/share/kmre/games.json

If the game you are using cannot be keystrokes, you can add the name of the game to the/usr/share/kylin-kmre/games.json file in the format of some existing game names in the file, as show in below:

    {
      "games": [
        {
            "pkgname": "com.tencent.tmgp.speedmobile",
            "appname": "QQ飞车"
        },
        {
            "pkgname": "com.tencent.tmgp.sgame",
            "appname": "王者荣耀"
        },
        {
            "pkgname": "com.tencent.tmgp.pubgmhd",
            "appname": "和平精英"
        },
        {
            "pkgname": "com.tencent.tmgp.carrot3dj",
            "appname": "保卫萝卜3"
        },
        {
            "pkgname": "com.qqgame.hlddz",
            "appname": "欢乐斗地主"
        },
        {
            "pkgname": "com.qqgame.happymj",
            "appname": "欢乐麻将全集"
        },
        {
            "pkgname": "com.happyelements.AndroidAnimal",
            "appname": "开心消消乐®"
        }
      ]
    }

<br>

## Resizable
kylin-kmre provides two ways to resize images and document content. hold down 'Ctrl' while scrolling the mouse wheel, or click the 'Zoom in' button on the toolbar at the bottom of the Android graphics window, and then use the mouse wheel again. Note: Use the mouse wheel to realize zoom in, some normal function can show some changes, such as using the WPS is opening a document, by default, when the mouse to scroll the contents of the document at the scroll, and after open the mouse wheel zoom function, when the mouse to scroll the document content can zoom in and out, is no longer the content of the scroll up and down.
