# 麒麟移动应用环境
## 概 述
麒麟移动应用环境（以下简称为kylin-kmre）是麒麟团队专为“银河麒麟操作系统”打造的一款兼容安卓App运行的系统环境，用于满足用户对应用软件的多样化需求。kylin-kmre 能够让用户在银河麒麟操作系统中安装和运行安卓App，比如游戏、微信、QQ极速版、股票、视频类App等。

### 技术特点
1）支持海量安卓App，一秒启动。

2）直接使用显卡硬件，无性能损失。

3）安卓App与Linux窗口显示融合。

4）多个App同时运行。

5）App分辨率动态适应，横竖屏幕切换，高分辨率真全屏模式。

6）统一输入法，使用Linux输入法在安卓App中输入文字。

7）统一音频设备，支持语音聊天。

8）支持摄像头。

9）文件互通，文字剪切板互通，应用管理统一。

10）支持微信、QQ极速版的新消息通知。

11）支持微信平板模式登录，和手机微信同时在线。

12）升级到安卓11，兼容性、安全性、稳定性大幅提升。

<br>

## 用前必读
因安卓系统本身技术设计，以及kylin-kmre与银河麒麟操作系统共用硬件资源的原因，为了达到较好的使用体验效果，建议用户仔细阅读以下注意事项和已知问题：

1）安卓App在使用固态硬盘时性能会相较于使用机械硬盘有较大提升（安卓操作系统为手机操作系统，其磁盘操作对机械硬盘支持较差）；

2）建议不要同时运行4个以上的App（安卓手机一般只会有一个App在前端活跃运行）；

3）电脑内存建议8G或以上；

4）当前版本支持的CPU包括FT-2000/4、Phytium D2000/8、FT1500A、Kirin990、Hygon、ZHAOXIN、Intel和AMD；

5）当前版本支持的显卡包括：NVIDIA、AMD、INTEL、JJM和GP101。在JJM和GP101显卡上，性能表现不佳，运行应用可能出现卡顿和闪退现象，甚至有些应用无法运行；

6）QQ极速版语音和视频通话正常，但是录像显示异常；

7）在使用音视频通话软件时，需要暂停其他音频/视频的播放，否则音视频通话软件可能会遇到听不到对方声音的问题；

8）如果要使用摄像头，则需要在kylin-kmre环境启动之前插上摄像头，否则当环境启动成功后才插上摄像头，将无法正常使用摄像头；当前版本在有些机器上使用摄像头可能存在绿屏现象；

9）带有wifi设备的机器，如笔记本或者台式机插入了无线网卡，这类机器在启动kylin-kmre环境之前，需要保证wifi开关处于开启状态，否则如果wifi开关处于关闭状态时启动kylin-kmre环境，则kylin-kmre环境里的App都无法联网；

10）视频类应用调节屏幕亮度功能不会生效；

11）视频类应用不支持“画中画”功能；

12）不支持定位和传感器相关功能；

13）“钉钉”应用登录后，如在钉钉上使用到打卡等功能，需要先在kylin-kmre环境中登出账号，否则可能出现“虚拟定位软件打卡”问题；

14）“蓝信+”应用，需要在手机上登出账号后，语音通话功能才能成功呼出；

15）如果系统安装了奇安信网神终端安全管理系统，要注意该杀毒软件的版本号。如果是8.0.5.1000，则会导致docker异常，进而导致安卓兼容无法使用，和软件商店“手机”页面无法刷新成功。出现这种情况时，需要更新该杀毒软件版本或者直接卸载该杀毒软件；

16）不支持虚拟机。

<br>

## 移动应用启动方式
### 从麒麟软件商店启动移动应用
点击左下角开始菜单->麒麟软件商店，如图 1所示。软件商店打开后，点击窗口左侧“手机”按钮。若为开机后第一次启动应用，则需初始化kylin-kmre环境，在该过程中，桌面右下角会弹出提示框，如图 2所示。待kylin-kmre环境准备完成后，提示框退出，软件商店“手机”页面将会出现移动应用列表，此时可以开始进行移动应用的安装，如图 3所示。

![图 1 启动银河麒麟软件商店-big](image/1.png)

![图 2 初始化kylin-kmre环境提示框-big](image/2.png)

![图 3 可安装的移动应用列表-big](image/3.png)

当kylin-kmre环境准备完毕，并且安装了移动应用后，我们可以选择通过麒麟软件商店启动移动应用。鼠标悬停在已安装应用上，如图 4所示，点击“启动”按钮，出现对应移动应用的界面，如图 5所示。

![图 4 启动移动应用-big](image/4.png)

![图 5 打开的移动应用软件](image/5.png)

### 从开始菜单快捷方式启动移动应用
点击桌面左下角开始菜单->所有软件->移动应用（安卓兼容）快捷方式，如图 6所示。

![图 6 在开始菜单中启动移动应用-big](image/6.png)

<br>

## 界面切换
### 切换
移动应用启动后，与麒麟系统应用一样，在任务栏有个对应的标签，如图 7所示。点击任务栏标签可以激活对应的应用，并且可以通过Alt+Tab键进行应用间的切换，如图 8所示。

![图 7 点击任务栏移动应用图标](image/7png)

![图 8 Alt+Tab切换-big](image/8.png)

### 移动应用窗口的全屏
窗口工具栏有三个功能按钮，分别为设置（暂未开放设置功能）、返回和全屏，如图 9所示，点击全屏按钮后，对应的应用将以全屏方式显示。在全屏模式下，鼠标移动时，将在屏幕的最右侧出现一个黑色的浮动工具栏，如图 10所示，点击该浮动工具栏的按钮，将展现一个包括设置（暂未开放设置功能）、返回和全屏按钮的工具栏，如图 11所示。也可以通过按“F11”进行全屏与非全屏的切换，支持“Esc”退出全屏。

![图 9 工具栏](image/9.png)

![图 10 全屏状态下的右侧浮动工具栏-big](image/10.png)

![图 11 全屏状态下的右侧固定工具栏-big](image/11.png)

<br>

## 安装卸载移动应用
- 安装和升级：麒麟软件商店打开后，点击左侧“手机”按钮，在按钮右侧窗口出现移动应用列表，鼠标移至应用处，点击“安装”按钮即可，如图 12所示。安装过后，该“安装”按钮将会变成“启动”按钮。

![图 12 安装应用-big](image/12.png)

- 卸载：点击想要卸载的应用，进入软件介绍界面，点击“卸载”按钮，见图 13。

![图 13 卸载应用-big](image/13.png)

<br>

## 输入
### 中文输入
kylin-kmre环境和麒麟系统环境共享输入法，切换输入法后，可以直接在移动应用的输入框中输入中文，如图 14所示。

![图 14 中文输入-big](image/14.png)

### 按键输入
kylin-kmre支持键盘按键输入，包括小键盘和各类组合键，如Ctrl+C、Ctrl+V等，如图 15所示。

![图 15 按键输入-big](image/15.png)

<br>

## 文件互通
在银河麒麟操作系统V10上，kylin-kmre提供了麒麟与移动应用环境文件互通功能，在启动kylin-kmre环境后，当前用户桌面上会创建一个名为“移动应用数据”的快捷方式，通过该快捷方式可以访问到kylin-kmre环境内部的数据；同时，也提供了一个安卓文件分类显示工具，通过该工具可以查看和拷贝安卓内的四类文件：图片、视频、音频和文档；并且，安卓应用可以直接访问麒麟端的文件，大大方便了文件传输和访问。

* 通过桌面上的“移动应用数据”快捷方式查看和访问安卓内的文件，如图 16所示。下面以微信为例进行描述，通过微信保存的照片或视频文件，会保存在“桌面”->“移动应用数据”->“Pictures”->“WeiXin”目录下；通过微信保存的文档文件，如doc文档、pdf文档、压缩文件等则会存放在“桌面” -> “移动应用数据” -> “Android” -> “data” -> “com.tencent.mm” -> “MicroMsg” -> “Download”目录下。

![图 16 移动应用数据文件夹-big](image/16.png)

* 通过菜单栏里的安卓文件分类显示工具“移动数据文件管理器”查看和访问安卓内的文件，如图 17、图 18、图 19、图 20所示，比如通过安卓微信保存的图片、文档等都可以在该工具内查看。

![图 17 单栏中的移动数据管理器](image/17.png)

![图 18 移动数据管理器主界面-big](image/18.png)

![图 19 移动数据管理器-视频-big](image/19.png)

![图 20 移动数据管理器-文档-big](image/20.png)

* 安卓应用直接访问麒麟端数据（以微信发送文件为例进行描述）

  - （a）微信发送照片：如图 21、图 22和图 23所示，先点击微信的“相册”按钮，在弹出的界面上选择进入某个文件夹，即可将文件夹中的图片发送给好友。

  ![图 21 微信选择照片的入口](image/21.png)

  ![图 22 微信可选择的所有图片目录](image/22.png)

  ![图 23 微信选择照片进行发送](image/23.png)

  - （b）微信发送文档：如图 24、图 25、图 26和图 27所示，先点击微信的“文件”按钮，在弹出的界面上选择“手机存储”，然后再选择“0-麒麟文件”即可将麒麟端的文件发送给好友。

  ![图 24 微信选择文档文件的入口](image/24.png)

  ![图 25 微信选择文件的列表项](image/25.png)

  ![图 26 微信从手机存储选择文档文件](image/26.png)

  ![图 27 微信选择文档文件进行发送](image/27.png)

<br>

## 修改网络配置
kylin-kmre运行在docker容器中，如果docker的网络配置与用户机器所在网络的网段一样，如172开头的网段，此时会造成容器中的麒麟移动应用环境没有网络。

遇到这种情况，可以修改docker的网络配置文件 /etc/docker/daemon.json后重启麒麟移动应用环境解决该问题。 如果该文件不存在，可自行创建该文件并添加类似如下的内容所述的内容：

    {
      "bip": "128.128.0.1/16"
    }

<br>

## 游戏键盘白名单设置
kylin-kmre可以为游戏设置按键进行游戏操作，可以设置按键操作的游戏名单在/usr/share/kmre/games.json中；

如果正在使用的游戏无法设置按键操作，用户在/usr/share/kmre/games.json文件中增加该游戏名即可，格式参照该文件中已存在的一些游戏名的格式，如下所示：

    {
      "games": [
        {
            "pkgname": "com.tencent.tmgp.speedmobile",
            "appname": "QQ飞车"
        },
        {
            "pkgname": "com.tencent.tmgp.sgame",
            "appname": "王者荣耀"
        },
        {
            "pkgname": "com.tencent.tmgp.pubgmhd",
            "appname": "和平精英"
        },
        {
            "pkgname": "com.tencent.tmgp.carrot3dj",
            "appname": "保卫萝卜3"
        },
        {
            "pkgname": "com.qqgame.hlddz",
            "appname": "欢乐斗地主"
        },
        {
            "pkgname": "com.qqgame.happymj",
            "appname": "欢乐麻将全集"
        },
        {
            "pkgname": "com.happyelements.AndroidAnimal",
            "appname": "开心消消乐®"
        }
      ]
    }

<br>

## 放大缩小
kylin-kmre提供两种方式支持对图片和文档内容的放大缩小，一是按住“Ctrl”的同时滚动鼠标滚轮，二是点击安卓图形窗口最下方工具栏上的“放大缩小”按钮，然后再使用鼠标滚轮。注意：使用鼠标滚轮来实现放大缩小的时候，一些正常功能可以表现出一些变化，如使用wps打开一个文档时，默认情况下鼠标滚动时文档会上下滚动显示的内容，而在开启鼠标滚轮的放大缩小功能后，鼠标滚动时文档内容则会放大和缩小，不再是上下滚动显示的内容了。
